﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class SetBusesGeneric<T>
        where T : class
    {
        /// <summary>
        /// Массив объектов, которые храним
        /// </summary>
        private readonly T[] _places;
        /// <summary>
        /// Количество объектов в массиве
        /// </summary>
        public int Count => _places.Length;
        private int BusyPlaces = 0;
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="count"></param>
        public SetBusesGeneric(int count)
        {
            _places = new T[count];
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="bus">Добавляемый автобус</param>
        /// <returns></returns>
        public int Insert(T bus)
        {
            return Insert(bus, 0);
        }
        /// <summary>
        /// Добавление объекта в набор на конкретную позицию
        /// </summary>
        /// <param name="bus">Добавляемый автомобиль</param>
        /// <param name="position">Позиция</param>
        /// <returns></returns>
        public int Insert(T bus, int position)
        {
            if (position < 0 || position >= _places.Length || BusyPlaces == _places.Length) return -1;

            BusyPlaces++;
            while (_places[position] != null)
            {
                for (int i = _places.Length - 1; i > 0; --i)
                {
                    if (_places[i] == null && _places[i - 1] != null)
                    {
                        _places[i] = _places[i - 1];
                        _places[i - 1] = null;
                    }
                }
            }
            _places[position] = bus;
            return position;
        }
        /// <summary>
        /// Удаление объекта из набора с конкретной позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Remove(int position)
        {
            if (position < 0 || position >= _places.Length) return null;
            T savedBus = _places[position];
            _places[position] = null;
            return savedBus;
        }
        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Get(int position)
        {
            if (position < 0 || position >= _places.Length) return null;
            return _places[position];
        }

    }
}
